From 894c5e45dcaa7b4eac7dce16bfcd86819f185e79 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jul 30 2020 01:21:50 +0000
Subject: [PATCH 662/2232] Add rust::Str(const char *, size_t) constructor


---

diff --git a/include/cxx.h b/include/cxx.h
index 5a33a7a..c3231fd 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -59,6 +59,7 @@ public:
 
   Str(const std::string &);
   Str(const char *);
+  Str(const char *, size_t);
   Str(std::string &&) = delete;
 
   Str &operator=(Str) noexcept;
diff --git a/src/cxx.cc b/src/cxx.cc
index 8614d39..da05ee2 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -106,13 +106,11 @@ Str::Str() noexcept : repr(Repr{reinterpret_cast<const char *>(this), 0}) {}
 
 Str::Str(const Str &) noexcept = default;
 
-Str::Str(const std::string &s) : repr(Repr{s.data(), s.length()}) {
-  if (!cxxbridge03$str$valid(this->repr.ptr, this->repr.len)) {
-    panic<std::invalid_argument>("data for rust::Str is not utf-8");
-  }
-}
+Str::Str(const std::string &s) : Str(s.data(), s.length()) {}
+
+Str::Str(const char *s) : Str(s, std::strlen(s)) {}
 
-Str::Str(const char *s) : repr(Repr{s, std::strlen(s)}) {
+Str::Str(const char *s, size_t len) : repr(Repr{s, len}) {
   if (!cxxbridge03$str$valid(this->repr.ptr, this->repr.len)) {
     panic<std::invalid_argument>("data for rust::Str is not utf-8");
   }

